/**
* @file main.cpp
*
* Copyright (C) 2020. Huawei Technologies Co., Ltd. All rights reserved.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/
#include <iostream>
#include "sample_process.h"
#include "utils.h"
#include "CameraDrivingPerceptionFour.h"
#include "int_test.h"
using namespace std;
bool g_isDevice = false;


int main()
{

    ara::log::InitLogging("MAIN", "Main of Camera Driving Perception", ara::log::LogLevel::kInfo,
                          (ara::log::LogMode::kConsole | ara::log::LogMode::kRemote));
    ara::log::Logger &mainLog{ara::log::CreateLogger("MAIN", "main context", ara::log::LogLevel::kInfo)};

    mainLog.LogInfo() << "start main!";

    CameraDrivingPerceptionFour c;
    c.init();
    setup_test();
    while (true)
    {
        std::this_thread::sleep_for(std::chrono::milliseconds(10));
    }
    SampleProcess sampleProcess;
    
    WARN_LOG("Resource initialization begin");
    Result ret = sampleProcess.InitResource();
    if (ret != SUCCESS) {
        ERROR_LOG("Resource initialization failed");
        return FAILED;
    }
    INFO_LOG("Resource initialization finished");

    WARN_LOG("Model processing begin");
    // while(1){
    ret = sampleProcess.Process();
    if (ret != SUCCESS) {
        ERROR_LOG("Model processing failed");
        return FAILED;
    }
    // }
    INFO_LOG("Model processing finished");

    return SUCCESS;
}